/* indybot - Copyright (C) 2004 bakunin - <bakunin@autistici.org>
 *
 * This source code is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Public License as published 
 * by the Free Software Foundation; either version 2 of the License,
 * or (at your option) any later version.
 *
 * This source code is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.
 * Please refer to the GNU Public License for more details.
 *
 * You should have received a copy of the GNU Public License along with
 * this source code; if not, write to:
 * Free Software Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifdef HAVE_CONFIG_H
#include <config.h>
#else
# error Use configure; make; make install
#endif

#include <indybot.h>

size_t
get_line (char *buff)
{
  register int b;
  static char line[SIZE_BUFFER];
  static int fill = 0;


  while (fill <= SIZE_BUFFER)
    {

      for (b = 0; b < fill; b++)
	{

	  if (*(line + b) == '\n')
	    {
	      memcpy (buff, line, b);
	      memmove (line, line + b + 1, SIZE_BUFFER - (b + 1));

	      fill -= b + 1;
	      *(buff + b) = 0;

	      return b;
	    }
	}

      if ((b = irc_read (line + fill, SIZE_BUFFER - fill)) <= 0)
	return 0;

      fill += b;
    }

  memcpy (buff, line, SIZE_BUFFER);
  fill = 0;

  return SIZE_BUFFER;
}

char *
check_part (char *buff)
{
  char *cmd = buff;

  buff = trim (buff);

  while (*buff++)
    if (*buff == ' ')
      {
	*buff = 0;
	break;
      }

  free (buff);
  return cmd;
}

char *
check_cmd (char *buff)
{
  int a = 0;
  char *cmd = NULL;

  while (*buff++)
    {
      if (*buff == ' ' || *buff == '\t')
	{
	  if (!a)
	    {
	      a++;
	      cmd = ++buff;
	    }
	  else
	    {
	      *buff = 0;
	      break;
	    }
	}
    }

  return cmd;
}

int
get_story_id (char *str)
{
  char b[10];
  char *end;
  int j = 0;

  end = str + strlen (str) - 1;

  while (*end--)
    if (*end == '/')
      break;

  while (*end++)
    if (*end == '.')
      break;
    else
      b[j++] = *end;

  b[j] = 0;

  return atoi (b);
}

static int
get_rss_id_string (char *str)
{
  char buf[512];
  int len, i, j;

  for (i = j = 0, len = strlen (str); i < len && j < sizeof (buf); i++)
    if (str[i] >= '0' && str[i] <= '9')
      buf[j++] = str[i];

  buf[j] = 0;

  return atoi (buf);
}

int
get_rss_id (mrss_item_t * item)
{
  int ret;

  if (item->pubDate && (ret = get_rss_id_string (item->pubDate)))
    return ret;

  if (item->guid && (ret = get_rss_id_string (item->guid)))
    return ret;

  if (item->link && (ret = get_rss_id_string (item->link)))
    return ret;

  return 0;
}

/* EOF */
